---
title: Metadata
slug: api/metadata
description: Learn how to retrieve and create standards/studies, asset groups, and assets with this comprehensive document. Explore request parameters, responses, and various elements such as forms, sections, repeats, questions, and more. Discover how to analyze and d
createdAt: 2023-06-23T15:43:57.000Z
---

# Retrieve a List of Standards/Studies

This request returns a list of Standards/Studies and their versions within the system.&#x20;

The resultant lists are grouped by the unique administered ID `aid` for the Standard/Study.

:::CodeblockTabs
Endpoint

```json
GET   {baseUrl}/fws/api/repository/container
```
:::

**Example response:**

```json
[
  {
    "aid": "01234567-89ab-cdef-0123-456789abcdef",
    "versions": [
      {
        "version": 0,
        "label": "",
        "name": "",
        "identifier": "",
        "versionLabel": "",
        "containerType": "STUDY",
        "updated": "ccyymmddThhmmss.sssZ",
        "status": "",
        "category": "NOT_IN_USE"
      }, 
      ...
    ]
  }, 
  ...
]

```

`containerType` can be either a STUDY or STANDARD.

`category` can be : NOT\_IN\_USE, PRODUCTION, REJECTED, IN\_REVIEW, IN\_PROGRESS, DRAFT

**Errors:&#x20;**&#x53;ee [Common Errors](https://docs.formedix.com/api/common-errors)

# Retrieve Details for a Standard/Study

Return a detailed version of the Standard/Study, including the owner, updated time, and rule compliance along with other standard or study details.

:::CodeblockTabs
Request

```json
GET   {baseUrl}/fws/api/repository/container/containerAID/version
```
:::

:::CodeblockTabs
Response

```json
{
    "uuid": "e016fadb-bc81-4fe3-9ce3-feedcaeced24",
    "aid": "e016fadb-bc81-4fe3-9ce3-feedcaeced24",
    "updated": "20230523T192843.439Z",
    "containerType": "STUDY",
    "version": 1,
    "versionLabel": "",
    "label": "",
    "name": "",
    "identifier": "",
    "therapeuticArea": [
        ""
    ],
    "sponsor": "",
    "program": "",
    "protocolID": "",
    "protocolName": "",
    "protocolTitle": "",
    "status": "Draft",
    "category": "DRAFT",
    "owner": "",
    "ruleCompliance": {
        "compliant": 0,
        "deviation": 0,
        "nonStandard": 0
    },
    "assetStatus": [
        {
          "category": "PRODUCTION",
          "name": "Production",
          "total": 20
        }
    ]
}
```
:::

`containerType` can be either STUDY or STANDARD

`assetStatus `contains the total count of assets for each Lifecycle state.

`category `can be: NOT\_IN\_USE, PRODUCTION, REJECTED, IN\_REVIEW, IN\_PROGRESS, DRAFT


`versionLabel`, `name`, `sponsor `and `program `are optional

`protocolID`, `protocolName `and `protocolTitle `are for STUDY containers only

`owner `is the username of the user that created the container

| **HTTP Status** | **Error Code**              | **Description**                                              |
| --------------- | --------------------------- | ------------------------------------------------------------ |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the containerAID. |
| 400             | invalid\_container\_version | A non-numeric value was specified as the version.            |

**Errors:&#x20;**&#x53;ee [Common Errors](https://docs.formedix.com/api/common-errors)

# Create a Standard or Study

This request can be used to create a Standard or Study.

:::CodeblockTabs
Endpoint

```json
POST   {baseUrl}/fws/api/repository/container
```
:::

**Example Request:**

```json
{
  "containerType": "STUDY",
  "versionLabel": "",
  "label": "",
  "name": "",
  "identifier": "",
  "description": [
    {
      "locale": "",
      "text": ""
    }, ...
  ],
  "therapeuticArea": [
    "", ...
  ],
  "sponsor": "",
  "program": "",
  "protocolID": "",
  "protocolName": "",
  "protocolTitle": "",
  "owner": ""
}
  
```

| **Request Parameters** | **Accepted Values**                                        |
| ---------------------- | ---------------------------------------------------------- |
| `containerType`        | \[Mandatory] STANDARD, STUDY                               |
| `versionLabel`         | \[Optional]                                                |
| `label`                | \[Mandatory]                                               |
| `name`                 | \[Optional]                                                |
| `identifier`           | \[Mandatory]                                               |
| `Description`          | \[Optional]                                                |
| `therapeuticArea`      | \[Optional]                                                |
| `sponsor`              | \[Optional]                                                |
| `program`              | \[Optional]                                                |
| `protocolID`           | \[Optional]                                                |
| `protocolName`         | \[Optional]                                                |
| `protocolTitle`        | \[Optional]                                                |
| `owner`                | \[Mandatory] UUID of the user to be specified as the owner |

`containerType` can be either `STANDARD` or `STUDY`.

`protocolID`, `protocolName` and `protocolTitle` are properties for Studies. If added to a request to create a Standard, they are ignored.

`owner `is used to assign a user ownership of the standard/study. This allows the user to make changes in the application. You can use the [List Users](https://docs.formedix.com/api/users#list-users) request to find the UUID of the user to be set as the owner.

**Example response:**

```json
{
  "aid": "01234567-89ab-cdef-0123-456789abcdef",
  "version": 0
}

```

**Errors:**

| **HTTP Status** | **Error Code**            |                                             |
| --------------- | ------------------------- | ------------------------------------------- |
| 400             | invalid\_container\_type  | Unrecognized **containerType** provided.    |
| 400             | value\_cannot\_be\_empty  | Empty **label** or **identifier** provided. |
| 404             | unknown\_user             | User specified as **owner** does not exist  |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

# Retrieve a List of Asset Groups for a Standard/Study

:::BlockQuote
Replace `containerAID` and `version` with your values.
:::

:::CodeblockTabs
Request

```json
GET   {baseUrl}/fws/api/repository/container/containerAID/version/assetgroup
```
:::

This request returns a list of Asset Groups within a Standard/Study in the system.&#x20;

You should get a list of Standards/Studies and their versions beforehand. Then choose the appropriate one to use in this request.

A summary of rule compliance is returned for each Asset Group.

`assetStatus `contains the total count of assets for each lifecycle state.

`category `can be: NOT\_IN\_USE, PRODUCTION, REJECTED, IN\_REVIEW, IN\_PROGRESS, DRAFT

List of possible Asset Group types:

- ADaM
- SDTM
- SEND
- DATA ACQUISITION
- SOURCE DATASET (i.e. DATA)
- DATASET

You can use `containerAID` and `version` to specify which Standard/Study to retrieve the Asset Groups for.

**Example response:**

```json
[
  {
    "aid": "01234567-89ab-cdef-0123-456789abcdef",
    "label": "",
    "name": "",
    "identifier": "",
    "updated": "ccyymmddThhmmss.sssZ",
    "assetGroupType": "DATASET",
    "ruleCompliance": {
      "compliant": 0,
      "deviation": 0,
      "nonStandard": 0
    },
	"assetStatus": [
      {
        "category": "",
        "name": "",
        "total": 0
      },
      ...
    ]
  }, 
  ...
]

```

**Errors:**

| **HTTP Status** | **Error Code**              |                                                              |
| --------------- | --------------------------- | ------------------------------------------------------------ |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the containerAID. |
| 400             | invalid\_container\_version | A non-numeric value was specified as the version.            |
| 404             | unknown\_container          | Unknown **containerAID**/**version** pair.                   |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

# Create an Asset Group

Add a new Asset Group to an existing standard or study. You can use `containerAID` and `version` to specify the standard/study to add the Asset Group to.

:::BlockQuote
Replace `containerAID` and `version` with your values.
:::

```json
POST   {baseUrl}/fws/api/repository/container/containerAID/version/assetgroup
```

**Example Request:**

```json
{
  "assetGroupType": "SDTM",
  "label": "",
  "name": "",
  "identifier": "",
  "standardName": "",
  "standardVersion": "",
  "forSubmission": true
}

```

| **Request Parameters** | **Accepted Values**                                   |
| ---------------------- | ----------------------------------------------------- |
| `assetGroupType`       | DATA\_ACQUISITION, SDTM, SEND, ADAM, DATASET, GENERIC |

`name`, `standardName`, `standardVersion` and `forSubmission` are optional fields.

The fields `standardName`, `standardVersion` and `forSubmission` are for Dataset Asset Group types only (DATASET, SDTM, SEND, ADAM). If these fields are supplied for another type of Asset Group, then an error is returned.

**Example response:**

```json
{
    "aid": "01234567-89ab-cdef-0123-456789abcdef"
 }

```

**Errors:**

| **HTTP Status** | **Error Code**                           |                                                                                                                     |
| --------------- | ---------------------------------------- | ------------------------------------------------------------------------------------------------------------------- |
| 400             | invalid\_assetgroup\_type                | Unrecognized **assetGroupType** supplied.                                                                           |
| 400             | incompatible\_property                   | One of (**standardName**, **standardVersion**, **forSubmission**) have been supplied for a non-Dataset Asset Group. |
| 400             | invalid\_workflow\_state&#xD;<br />&#xD; | Container is in a non-editable state.                                                                               |
| 400             | value\_cannot\_be\_empty                 | Empty **label** or **identifier** provided.                                                                         |
| 400             | invalid\_container\_aid                  | An invalid AdministeredID was specified as the containerAID.                                                        |
| 400             | invalid\_container\_version              | A non-numeric value was specified as the version.                                                                   |
| 404             | unknown\_container                       | Unknown **containerAID**/**version** pair.                                                                          |

See also [Common Errors](https://docs.formedix.com/api/common-errors)



# Retrieve a List of Assets for an Asset Group in a Standard/Study

:::BlockQuote
Replace `containerAID`, `version`, and `assetgroupAID` with your values.
:::

:::CodeblockTabs
Request

```json
GET   {baseUrl}/fws/api/repository/container/containerAID/version/assetgroup/assetgroupAID/asset
```
:::

This request returns a list of Assets within an Asset Group for a Standard/Study in the system. The response may be 'chunked' into partial results, depending on size.

The rule compliance type of each asset is returned.

`assetStatus `contains the total count of assets for each lifecycle state.

`category `can be: NOT\_IN\_USE, PRODUCTION, REJECTED, IN\_REVIEW, IN\_PROGRESS, DRAFT

Before making this request, you should first get a list of Standards/Studies and their versions, then get a list of Asset Groups for one Standard/Study.

You can use `containerAID` and `version` to specify the Standard/Study, and `assetgroupAID` to specify the Asset Group to retrieve the Assets for.

**Example response:**

```json
[
  {
    "aid": "01234567-89ab-cdef-0123-456789abcdef",
    "label": "",
    "name": "",
    "identifier": "",
    "updated": "ccyymmddThhmmss.sssZ",
    "assetType": "DATASET",
    "alias": [
      {
        "context": "",
        "name": "",
        "orderNumber": 0
      }, ...	
    ],
    "description": [
      {
        "locale": "",
        "text": "",
        "orderNumber":0
      }, ...
    ],
    "therapeuticArea": [
      "", ...
    ],
    "clinicalStage": [
      "", ...
    ],
    "ruleCompliance": "COMPLIANCE",
    "assetStatus": {
      "name": "", 
      "category": ""
    }
  }, ...
]

```

:::BlockQuote
The response returns a list of possible Assets and includes the `assetType`, For example: FORM, SECTION, QUESTION, TERM, METHOD, VARIABLE, COMMENT, etc.
:::

**Errors:**

| **HTTP Status** | **Error Code**              |                                                                         |
| --------------- | --------------------------- | ----------------------------------------------------------------------- |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the **containerAID**.        |
| 400             | invalid\_container\_version | A non numeric value was specified as the **version**.                   |
| 404             | unknown\_container          | Unknown **containerAID**/**version** pair.                              |
| 404             | unknown\_assetgroup         | Unknown **assetGroupAID** within the **containerAID**/**version** pair. |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

# Retrieve a List of Assets for an Asset Group Filtered by Asset Type



:::CodeblockTabs
Request

```json
GET   {baseUrl}/fws/api/repository/container/containerAID/containerVersion/assetgroup/assetGroupAID/assetType
```
:::

Return a list of Assets in an Asset Group which has been filtered by the specified Asset Type.

`containerAID `and `containerVersion `specify the Container in which the Asset Group exists.

`assetGroupAID `specifies the Asset Group being filtered.

The `assetType `can be `VISIT`, `FORM`, `DATASET`, `TERMINOLOGY `or `FILE`.

`assetStatus `contains the total count of assets for each lifecycle state.
`category `can be: NOT\_IN\_USE, PRODUCTION, REJECTED, IN\_REVIEW, IN\_PROGRESS, DRAFT


:::CodeblockTabs
Response

```json
[
  {
    "aid": "da742a14-9b6c-4e23-bf86-74ec29ec7da3",
    "label": "",
    "name": "”,
    "identifier": "",
    "updated": "20230101T010203.456Z",
    "assetType": "FORM",
    "alias": [
      {
        "context": "",
        "name": "",
        "orderNumber": 0
      }, ...	
    ],
    "description": [
      {
        "locale": "",
        "text": "",
	    "orderNumber": 0
      }, ...
    ],
    "therapeuticArea": [
      "", ...
    ],
    "clinicalStage": [
      "", ...
    ],
    "ruleCompliance": "NONSTANDARD",
    "assetStatus": {
      "name": "", 
      "category": ""
    }
  }, ...
]
```
:::

**Errors:**

| **HTTP Status** | **Error Code**              |                                                                                                     |
| --------------- | --------------------------- | --------------------------------------------------------------------------------------------------- |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the **containerAID**.                                    |
| 400             | invalid\_container\_version | A non numeric value was specified as the **version**                                                |
| 400             | invalid\_assetgroup\_aid    | An invalid AdministeredID was specified as the **assetgroupAID**.                                   |
| 400             | asset\_type\_not\_supported | Asset type not one of the following: **VISIT**, **FORM**, **DATASET**, **TERMINOLOGY** or **FILE**. |
| 404             | unknown\_container          | Could not find specified container using provided **containerAID**/**version** pair.                |
| 404             | unknown\_asset\_group       | Could not find specified asset group with provided **assetGroupAID**.                               |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

# Create an Asset

:::CodeblockTabs
Endpoint

```json
POST   {baseUrl}/fws/api/repository/container/containerAID/version/asset
```
:::

:::BlockQuote
Replace `containerAID` and `version` with your values.
:::

When creating Assets, it is recommended that you start with the lowest level of referenced asset. For example, if you are creating a Section which references Questions; then you must create the Question assets first, either in the UI or by using the API. Similarly, if the Question assets reference a Terminology, then the Terminology must be created first.

It may be easier to create and manage lower level assets in ryze instead of creating them in the API.

**Example Request:**

```json
{
    "assetType": "SECTION",
    "label": "Section Label",
    "name": "Section Name",
    "identifier": "S_1",
    "description": [
        {
            "locale": "",
            "text": "Section description"
        },
        {
            "locale": "fr-FR",
            "text": "Section French description"
        }
    ],
    "aliases": [
        {
            "context": "RAVE",
            "name": "Section Rave Alias"
        },
        {
            "context": "SDTM",
            "name": "Section SDTM Alias"
        }
    ],
    "clinicalStage": [
        "Study setup"
    ],
    "therapeuticArea": [
        "Devices",
        "Hematology"
    ],
    "repeating": true,
    "repeat": {
        "repeatType": "SIMPLE",
        "simpleRepeats": 2,
        "repeatQuestion": "{{questionAID}}",
        "repeatsPerTerm": 1,
        "otherQuestion": "{{questionAID}}",
        "otherTerms": [
            "{{termAID}}"
        ]
    },
    "questions": [
        {
            "aid": "{{questionAID}}",
            "orderNumber": 5,
            "mandatory": true,
            "condition": "{{conditionAID}}",
            "method": "{{methodAID}}"
        }
    ]
}

```

Create an Asset within a standard/study. You can use `containerAID` and `version` to specify the container.

**Example Response:**

```json
{
  “aid”: “01234567-89ab-cdef-0123-456789abcdef”
}

```

| **Request Parameters** | **Accepted Values**                                                                                                                                                                                               |
| ---------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `assetType`            | \[Mandatory] VISIT\_SCHEDULE, VISIT, FORM, SECTION, QUESTION, CONDITION, METHOD, UNIT, DATASET, VARIABLE, VALUE, SELECTION\_CRITERIA, RESULT\_DISPLAY, ANALYSIS\_RESULT, TERMINOLOGY, TERM, COMMENT, FILE or LINK |
| `label`                | \[Mandatory]                                                                                                                                                                                                      |
| `name`                 | \[Optional]                                                                                                                                                                                                       |
| `identifier`           | \[Mandatory]                                                                                                                                                                                                      |
| `clinicalStage`        | \[Optional]                                                                                                                                                                                                       |
| `therapeuticArea`      | \[Optional]                                                                                                                                                                                                       |

| **Description Properties** | **Description** |
| -------------------------- | --------------- |
| `description`              | \[Optional]     |
| `locale`                   | \[Optional]     |
| `text`                     | \[Optional]     |

| **Aliases Properties** | **Description** |
| ---------------------- | --------------- |
| `aliases`              | \[Optional]     |
| `context`              | \[Optional]     |
| `name`                 | \[Optional]     |
| `orderNumber`          | \[Optional]     |

The following properties are applicable depending on the `assetType` and must be appended to the previous request. Properties are split by asset type and each asset type includes details of it's restrictions and optionality:

```json
{
  ...
  visits: [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0,
      "mandatory": true,
      "condition": "01234567-89ab-cdef-0123-456789abcdef"
    }, ...
  ]
}
```

**Errors:**

****

| **HTTP Status** | **Error Code**              |                                                                                                                                                                                                                                |
| --------------- | --------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| 400             | value\_cannot\_be\_empty    | Empty **label** or **identifier** provided. Or empty **code** provided for **TERM** asset.                                                                                                                                     |
| 400             | invalid\_class\_type        | **classType** provided for **DATASET** asset is not one of the required values.                                                                                                                                                |
| 400             | invalid\_comparator         | **comparator** provided for **QUESTION** or **SELECTION\_CRITERIA** asset is not one of the required values.                                                                                                                   |
| 400             | invalid\_data\_type         | **dataType** provided for **QUESTION**, **VARIABLE**, **VALUE**, **TERMINOLOGY** or **METHOD** asset is not one of the required values.                                                                                        |
| 400             | invalid\_order\_number      | A duplicate **orderNumber** has been included.                                                                                                                                                                                 |
| 400             | invalid\_origin\_type       | **originType** provided for **VARIABLE** or **VALUE** asset is not one of the required values.                                                                                                                                 |
| 400             | invalid\_repeat\_type       | **repeatType** provided for **SECTION** asset is not one of the required values.                                                                                                                                               |
| 400             | invalid\_severity           | **severity** provided for **QUESTION** asset is not one of the required values.                                                                                                                                                |
| 400             | invalid\_source             | **source** provided for **VARIABLE** or **VALUE** asset is not one of the required values.                                                                                                                                     |
| 400             | invalid\_visit\_type        | **visitType** provided for **VISIT** asset is not one of the required values.                                                                                                                                                  |
| 400             | invalid\_workflow\_state    | Container is not editable.                                                                                                                                                                                                     |
| 400             | invalid\_term\_properties   | **externalDictionary** and **terms** have both been provided for a **TERMINOLOGY** asset.                                                                                                                                      |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the **containerAID**.                                                                                                                                                               |
| 400             | invalid\_container\_version | A non numeric value was specified as the **version**.                                                                                                                                                                          |
| 404             | unknown\_asset\_referenced  | An asset of this type with this aid cannot be found. Returned when an asset attempts to reference a child asset that does not exist, e.g. a **FORM** references a **SECTION** but a **SECTION** with that aid cannot be found. |
| 404             | unknown\_container          | Unknown **containerAID**/**version** pair                                                                                                                                                                                      |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

## Visit Schedule

| **Request Parameters** | **Description**                                    |
| ---------------------- | -------------------------------------------------- |
| `aid`                  | The AID of an existing Visit.                      |
| `orderNumber`          | Should be unique in the list.                      |
| `mandatory`            | \[Optional] Specifies if the property is mandatory |
| `condition`            | \[Optional] The AID of an existing Condition.      |

## Visit

```json
{
  ...
  repeating: true,
  visitType: "SCHEDULED",
  category: "",
  forms: [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0,
      "mandatory": true,
      "condition": "01234567-89ab-cdef-0123-456789abcdef"
    }, ...
  ]
}
```

| **Request Parameters** | **Description**                                    |
| ---------------------- | -------------------------------------------------- |
| `repeating`            | \[Optional]                                        |
| `visitType`            | Must be SCHEDULED, UNSCHEDULED or COMMON           |
| `category`             | \[Optional]                                        |
| `forms`                | \[Optional]                                        |
| `aid`                  | The AID of an existing Form.                       |
| `orderNumber`          | Should be unique in the list.                      |
| `mandatory`            | \[Optional] Specifies if the property is mandatory |
| `condition`            | \[Optional] The AID of an existing Condition.      |

## Form

```json
{
  ...
  "repeating": true,
  "sections": [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0,
      "mandatory": true,
      "condition": "01234567-89ab-cdef-0123-456789abcdef"
    }, ...
  ]
}
```

| **Request Parameters** | **Description**                                    |
| ---------------------- | -------------------------------------------------- |
| `aid`                  | The AID of an existing Section.                    |
| `orderNumber`          | Should be unique in the list.                      |
| `mandatory`            | \[Optional] Specifies if the property is mandatory |
| `condition`            | \[Optional] The AID of an existing Condition.      |

## Section

```json
{
  ...
  "repeating": true,
  "repeat": {
    "repeatType": "SIMPLE",
    "simpleRepeats": 0,
    "repeatQuestion": "01234567-89ab-cdef-0123-456789abcdef",
    "repeatsPerTerm": 0,
    "otherQuestion": "01234567-89ab-cdef-0123-456789abcdef",
    "otherTerms": [
      "01234567-89ab-cdef-0123-456789abcdef", ...
    ]
  },
  "questions": [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0,
      "mandatory": true,
      "condition": "01234567-89ab-cdef-0123-456789abcdef",
      "method": "01234567-89ab-cdef-0123-456789abcdef",
    }, ...
  ]
}
```

| **Request Parameters** | **Description** |
| ---------------------- | --------------- |
| `repeating`            | \[Optional]     |
| `repeat`               | \[Optional]     |

| **Repeat Properties** | **Description**                               |
| --------------------- | --------------------------------------------- |
| `repeatType `         | Must be SIMPLE or TERMINOLOGY                 |
| `simpleRepeats `      | \[Optional]                                   |
| `repeatQuestion `     | \[Optional] AID of an existing Question.      |
| `repeatsPerTerm `     | \[Optional]                                   |
| `otherQuestion  `     | \[Optional] AID of an existing Question.      |
| `otherTerms   `       | \[Optional] A list of AIDs of existing Terms. |

| **Question Properties** | **Description**                                    |
| ----------------------- | -------------------------------------------------- |
| `questions `            | \[Optional]                                        |
| `category`              | \[Optional]                                        |
| `aid`                   | The AID of an existing Question.                   |
| `orderNumber`           | Should be unique in the list.                      |
| `mandatory`             | \[Optional] Specifies if the property is mandatory |
| `condition`             | \[Optional] The AID of an existing Condition.      |
| `method`                | \[Optional] The AID of an existing Method.         |

## Question

```json
{
  ...
  "dataType": "TEXT",
  "question": [
    {
      "locale": "",
      "text": ""
    }, ...
  ],
  "length": 0,
  "fractionDigits": 0,
  "submissionVariable": "",
  "rangeChecks": [
    {
      "severity": "SOFT",
      "comparator": "LT",
      "values": [
        {
    "value": "",
    "aid": "01234567-89ab-cdef-0123-456789abcdef"
   }, ...  
      ],
      "formalExpressions": [
        {
          "context": "",
          "expression": ""
        }, ...
      ],
      "errorMessage": [
        {
          "locale": "",
          "text": ""
        }, ...
      ]
    }, ...
  ],
  "terminology": "01234567-89ab-cdef-0123-456789abcdef",
  "units": [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0
    }, ...
  ]
}

```

| **Request Parameters** | **Description**                                                                                                                                                                                                                                                                           |
| ---------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `dataType`             | Must be one of the following: TEXT, INTEGER, FLOAT, DATE, TIME, DATETIME, STRING, BOOLEAN, DOUBLE, HEXBINARY, BASE64BINARY, HEXFLOAT, BASE64FLOAT, PARTIALDATE, PARTIALTIME, PARTIALDATETIME, DURATIONDATETIME, INTERVALDATETIME, INCOMPLETEDATETIME, INCOMPLETEDATE, INCOMPLETETIME, URI |
| `question`             | \[Optional]                                                                                                                                                                                                                                                                               |
| `length`               | \[Optional]                                                                                                                                                                                                                                                                               |
| `fractionDigits`       | \[Optional]                                                                                                                                                                                                                                                                               |
| `submissionVariable `  | \[Optional]                                                                                                                                                                                                                                                                               |
| `terminology `         | \[Optional] the AID of an existing Terminology                                                                                                                                                                                                                                            |

| **rangeCheck Properties** | **Description**                                                        |
| ------------------------- | ---------------------------------------------------------------------- |
| `rangeChecks`             | \[Optional]                                                            |
| `severity `               | Must be SOFT or HARD                                                   |
| `comparator  `            | LT, LE, GT, GE, EQ, NE, IN, NOTIN.                                     |
| `unit  `                  | \[Optional]  the AID of an existing Unit                               |
| `values  `                | \[Optional] List of strings with `aid` as the AID of an existing Unit. |
| `formalExpressions   `    | \[Optional]                                                            |
| `errorMessage   `         | \[Optional]                                                            |

| **Unit Properties** | **Description**               |
| ------------------- | ----------------------------- |
| `units`             | \[Optional]                   |
| `aid`               | The AID of an existing Unit.  |
| `orderNumber`       | Should be unique in the list. |

```json
{
  ...
  "symbol": [
    {
      "locale": "",
      "text": ""
    }, ...
  ]
}
```

## Unit

| **Request Parameters** | **Description** |
| ---------------------- | --------------- |
| `symbol`               | \[Optional]     |

## Condition

```json
{
  ...
  "formalExpressions": [
    {
      "context": "",
      "expression": ""
    }, ...
  ]
}
```

| **Request Parameters** | **Description** |
| ---------------------- | --------------- |
| `formalExpressions `   | \[Optional]     |

## Method

```json
{
  ...
  "dataType": "COMPUTATION",
  "formalExpressions": [
    {
      "context": "",
      "expression": ""
    }, ...
    ]
  "documents": [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0,
      "pageRefs": [
        {
          "orderNumber": 0,
          "pageNumber": "",
          "pageRange": "",
          "title": "",
          "destination": [
            "", ...
          ]
        }, ...
      ]
    }, ...
  ]
}
```

| **Request Parameters** | **Description**                                     |
| ---------------------- | --------------------------------------------------- |
| `formalExpressions`    | \[Optional]                                         |
| `dataType`             | Must be COMPUTATION, IMPUTATION, TRANSPOSE or OTHER |
| `documents`            | \[Optional]                                         |

| **Documents Properties** | **Description**              |
| ------------------------ | ---------------------------- |
| `aid`                    | The AID of an existing File. |
| `orderNumber`            | must be unique in the list.  |

| **pageRef Properties** | **Description**                         |
| ---------------------- | --------------------------------------- |
| `pageRef`              | \[Optional]                             |
| `orderNumber `         | \[Optional] must be unique in the list. |
| `pageNumber `          | \[Optional]                             |
| `pageRange `           | \[Optional]                             |
| `title`                | \[Optional]                             |
| `destination `         | \[Optional]                             |

## Dataset

```json
{
  ...,
  "domain": "",
  "class": {
    "classType": "EVENTS",
    "subclass": {
      "subclass": "",
      "subSubclass": {
        "subclass": "",
        "subSubclass": {...}
	 }
    }
  },
  "repeating": true,
  "structure": "",
  "purpose": "",
  "referenceData": true,
  "location": "",
  "comment": "01234567-89ab-cdef-0123-456789abcdef",
  "variables": [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0,
      "mandatory": true,
      "keySequence": 0,
      "role": "",
      "method": "01234567-89ab-cdef-0123-456789abcdef",
      "hasNoData": "",
      "nonStandard": ""
    }
  ],
  "hasNoData": ""
}
```

| **Request Parameters**   | **Description**                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| ------------------------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `domain`                 | \[Optional]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| `class`                  |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| `classType`              | Contains class type object. Must be one of: TRIAL\_DESIGN, SPECIAL\_PURPOSE, INTERVENTIONS, EVENTS, FINDINGS, FINDINGS\_ABOUT, RELATIONSHIP, WILDCARD, SUBJECT\_LEVEL\_ANALYSIS\_DATASET, ADVERSE\_EVENT\_ANALYSIS\_DATASET, BASIC\_DATA\_STRUCTURE, ADAM\_OTHER, STUDY\_REFERENCE, OCCURRENCE\_DATA\_STRUCTURE, INTEGRATED\_SUBJECT\_LEVEL, INTEGRATED\_BASIC\_DATA\_STRUCTURE, INTEGRATED\_OCCURRENCE\_DATA\_STRUCTURE or NONE                                                                                                                                                   |
| `subClass`               | \[Optional] recursive property for the class. `subSubclass `within `subclass `is optional.<br />Example JSON snippets:<br />- `{..."class": { "classType": "EVENTS" }, ...}`<br />- `{..."class": { "classType": "EVENTS", "subclass": { "subclass": "text" } }, ...}`<br />- `{..."class": { "classType": "EVENTS", "subclass": { "subclass": "text", "subSubclass": { "subclass": "text2" } } }, ...}`<br />- `{..."class": { "classType": "EVENTS", "subclass": { "subclass": "text", "subSubclass": { "subclass": "text2", "subSubclass": { "subclass": "text3" } } } }, ...}` |
| `repeating`              | \[Optional] \[defaults to TRUE]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| `structure`              | \[Optional]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| `purpose`                | \[Optional]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| `referenceData`          | \[Optional]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| `location`               | \[Optional]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| `comment`                | \[Optional]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| `variables`              | \[Optional]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| **Variables Properties** | **Description**                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| `aid`                    | The AID of an existing Variable.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| `orderNumber`            | Should be unique in the list.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| `mandatory`              | \[Optional] Specifies if the property is mandatory                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| `keySequence`            | \[Optional]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| `role`                   | \[Optional]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| `method`                 | \[Optional] The AID of an existing Method.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| `hasNoData`              | \[Optional] \[Boolean] Indicates that an Dataset has no records. Can be `true `or `false`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| `nonStandard`            | \[Optional] \[Boolean] Indicates that an Dataset has no records. Can be `true `or `false`. indicates that this Variable is not defined in the Implementation Guide standard referenced by the parent Dataset.                                                                                                                                                                                                                                                                                                                                                                      |

## Variable

```json
{
  ...,
  "dataType": "INTEGER",
  "length": 0,
  "fractionDigits": 0,
  "displayFormat": "",
  "originRefs": [
    {
      "orderNumber": 0,
      "originType": "COLLECTED",
      "source": "SUBJECT",
      "description": "",
      "documents": [
        {
          "aid": "01234567-89ab-cdef-0123-456789abcdef",
          "orderNumber": 0,
          "pageRefs": [
            {
              "orderNumber": 0,
              "pageNumber": "",
              "pageRange": "",
              "title": "",
              "destination": [
                "", ...
              ]
            }, ...
          ]
        }, ...
      ]
    }, ...
  ],
  "comment": "01234567-89ab-cdef-0123-456789abcdef",
  "terminology": "01234567-89ab-cdef-0123-456789abcdef",
  "values": [
    "aid": "01234567-89ab-cdef-0123-456789abcdef",
    "orderNumber": 0,
    "mandatory": true,
    "keySequence": 0,
    "role": "",
    "method": "01234567-89ab-cdef-0123-456789abcdef",
    "selectionCriterias": [
      {
        "aid": "01234567-89ab-cdef-0123-456789abcdef",
        "orderNumber": 0,
        "mandatory": true
      }, ...
    ],
    "hasNoData": ""
  ],
  "coreCategory": "Global"
}
```

| **Request Parameters**               | **Description**                                                                                                                                       |
| ------------------------------------ | ----------------------------------------------------------------------------------------------------------------------------------------------------- |
| `dataType `                          | Must be TEXT, INTEGER, FLOAT, DATE, TIME, DATETIME, PARTIALDATE, PARTIALTIME, PARTIALDATETIME, DURATIONDATETIME, INTERVALDATETIME, INCOMPLETEDATETIME |
| `length`                             | \[Optional]                                                                                                                                           |
| `fractionDigits`                     | \[Optional]                                                                                                                                           |
| `displayFormat`                      | \[Optional]                                                                                                                                           |
| `originRefs`                         | \[Optional]                                                                                                                                           |
| `comment`                            | \[Optional]  the AID of an existing Comment                                                                                                           |
| `terminology `                       | \[Optional]  the AID of an existing Terminology                                                                                                       |
| `values `                            | \[Optional]                                                                                                                                           |
| coreCategory                         | \[Optional] String that indicates whether an ADSL variable is a “Core” variable. Free text, for example “Global”, “Safety”, “Efficacy”.               |
| **originRef Properties**             | **Description**                                                                                                                                       |
| `originRefs `                        | \[Optional]                                                                                                                                           |
| `orderNumber`                        | Should be unique in the list.                                                                                                                         |
| `originType `                        | Must be COLLECTED, DERIVED, ASSIGNED, PROTOCOL, PREDECESSOR, NOT\_AVAILABLE                                                                           |
| `source  `                           | \[Optional] Must be SUBJECT, INVESTIGATOR, VENDOR, SPONSOR                                                                                            |
| `description `                       | \[Optional]                                                                                                                                           |
| `documents `                         | \[Optional]                                                                                                                                           |
| **Document** **Properties**          | **Description**                                                                                                                                       |
| `aid`                                | The AID of an existing File.                                                                                                                          |
| `orderNumber`                        | Should be unique in the list.                                                                                                                         |
| `mandatory`                          | \[Optional] Specifies if the property is mandatory                                                                                                    |
| `keySequence`                        | \[Optional] Specifies if the property is mandatory                                                                                                    |
| `role`                               | \[Optional]                                                                                                                                           |
| `method `                            | \[Optional] the AID of an existing Method                                                                                                             |
| `selectionCriterias `                | \[Optional]                                                                                                                                           |
| `hasNoData`                          | \[Optional] \[Boolean] Indicates that the value has no data. Can be `true `or `false`.                                                                |
| **selctionCriterias** **Properties** | **Description**                                                                                                                                       |
| `aid`                                | The AID of an existing Criteria.                                                                                                                      |
| `orderNumber`                        | Should be unique in the list.                                                                                                                         |
| `mandatory`                          | \[Optional] Specifies if the property is mandatory                                                                                                    |

## Value

```json
{
  ...
  "dataType": "FLOAT",
  "length": 0,
  "fractionDigits": 0,
  "displayFormat": "",
  "originRefs": [
    {
      "orderNumber": 0,
      "originType": "DERIVED",
      "source": "VENDOR",
      "description": "",
      "documents": [
        {
          "aid": "01234567-89ab-cdef-0123-456789abcdef",
          "orderNumber": 0,
          "pageRefs": [
            {
              "orderNumber": 0,
              "pageNumber": "",
              "pageRange": "",
              "title": "",
              "destination": [
                "", ...
              ]
            }, ...
          ]
        }, ...
      ]
    }, ...
  ],
  "comment": "01234567-89ab-cdef-0123-456789abcdef",
  "terminology": "01234567-89ab-cdef-0123-456789abcdef"
}
```

| **Request Parameters**      | **Description**                                                                                                                                       |
| --------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------- |
| `dataType `                 | Must be TEXT, INTEGER, FLOAT, DATE, TIME, DATETIME, PARTIALDATE, PARTIALTIME, PARTIALDATETIME, DURATIONDATETIME, INTERVALDATETIME, INCOMPLETEDATETIME |
| `length`                    | \[Optional]                                                                                                                                           |
| `fractionDigits`            | \[Optional]                                                                                                                                           |
| `displayFormat`             | \[Optional]                                                                                                                                           |
| `originRefs`                | \[Optional]                                                                                                                                           |
| `comment`                   | \[Optional]  the AID of an existing Comment                                                                                                           |
| `terminology `              | \[Optional]  the AID of an existing Terminology                                                                                                       |
| **originRef Properties**    | **Description**                                                                                                                                       |
| `orderNumber`               | Should be unique in the list.                                                                                                                         |
| `originType `               | Must be COLLECTED, DERIVED, ASSIGNED, PROTOCOL, PREDECESSOR, NOT\_AVAILABLE                                                                           |
| `source  `                  | \[Optional] Must be SUBJECT, INVESTIGATOR, VENDOR, SPONSOR                                                                                            |
| `description `              | \[Optional]                                                                                                                                           |
| `documents `                | \[Optional]                                                                                                                                           |
| **Document** **Properties** | **Description**                                                                                                                                       |
| `aid`                       | The AID of an existing File.                                                                                                                          |
| `orderNumber`               | Should be unique in the list.                                                                                                                         |
| `mandatory`                 | \[Optional] Specifies if the property is mandatory                                                                                                    |
| `keySequence`               | \[Optional]                                                                                                                                           |
| `method `                   | \[Optional] the AID of an existing Method                                                                                                             |

| **pageRef Properties** | **Description**                         |
| ---------------------- | --------------------------------------- |
| `pageRef`              | \[Optional]                             |
| `orderNumber `         | \[Optional] must be unique in the list. |
| `pageNumber `          | \[Optional]                             |
| `pageRange `           | \[Optional]                             |
| `title`                | \[Optional]                             |
| `destination `         | \[Optional]                             |

## Selection Criteria

```json
{
  ...
  "criteria": [
    {
      "variable": "01234567-89ab-cdef-0123-456789abcdef",
      "comparator": "GT",
      "values": [
        "", ...
      ],
      "terms": [
        {
          "aid": "01234567-89ab-cdef-0123-456789abcdef",
          "orderNumber": 0,
          "rank": 0.0
        }, ...
      ]
    }, ...
  ],
  "comment": "01234567-89ab-cdef-0123-456789abcdef"
}
```

| **Request Parameters**  | **Description**                                              |
| ----------------------- | ------------------------------------------------------------ |
| `criteria`              | \[Optional]                                                  |
| `comment`               | \[Optional] The AID of an existing Comment                   |
| **Criteria Properties** | **Description**                                              |
| `variable`              | \[Optional]                                                  |
| `comparator`            | \[Optional] Must be one of LT, LE, GT, GE, EQ, NE, IN, NOTIN |
| `values`                | \[Optional]                                                  |
| `terms`                 | \[Optional]                                                  |
| **Terms Properties**    | **Description**                                              |
| `aid`                   | The AID of an existing Term.                                 |
| `orderNumber`           | Should be unique in the list.                                |
| `rank`                  | \[Optional]                                                  |

## Result Display

```json
{
  ...
  "analysisResults": [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0
    }, ...
  ],
  "documents": [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0,
      "pageRefs": [
        {
          "orderNumber": 0,
          "pageNumber": "",
          "pageRange": "",
          "title": "",
          "destination": [
            "", ...
          ]
        }, ...
      ]
    }, ...
  ]
}
```

| **Request Parameters** | **Description** |
| ---------------------- | --------------- |
| `analysisResults`      | \[Optional]     |

| **analysisResults Properties** | **Description**               |
| ------------------------------ | ----------------------------- |
| `aid`                          | The AID of an existing Term.  |
| `orderNumber`                  | Should be unique in the list. |

| **documents Properties** | **Description**               |
| ------------------------ | ----------------------------- |
| `aid`                    | The AID of an existing File.  |
| `orderNumber`            | Should be unique in the list. |
| `pageRefs`               | \[Optional]                   |

| **pageRef Properties** | **Description**                         |
| ---------------------- | --------------------------------------- |
| `pageRef`              | \[Optional]                             |
| `orderNumber `         | \[Optional] must be unique in the list. |
| `pageNumber `          | \[Optional]                             |
| `pageRange `           | \[Optional]                             |
| `title`                | \[Optional]                             |
| `destination `         | \[Optional]                             |

## Analysis Result

```json
{
  ...
  "analysisReason": "",
  "analysisPurpose": "",
  "parameter": "01234567-89ab-cdef-0123-456789abcdef",
  "analysisDataset": {
    "comment": "01234567-89ab-cdef-0123-456789abcdef",
    "datasets": [
      {
        "aid": "01234567-89ab-cdef-0123-456789abcdef",
        "orderNumber": 0,
        "selectionCriteria": "01234567-89ab-cdef-0123-456789abcdef",
        "variables": [
          {
            "aid": "01234567-89ab-cdef-0123-456789abcdef",
            "orderNumber": 0,
            "mandatory": true,
            "keySequence": 0,
            "role": "",
            "method": "01234567-89ab-cdef-0123-456789abcdef"
          }, ...
        ]
      }, ...
    ]
  },
  "analysisDocumentation": {
    "description": [
      {
        "locale": "",
        "text": ""
      }, ...
    ],
    "documents": [
      {
        "aid": "01234567-89ab-cdef-0123-456789abcdef",
        "orderNumber": 0,
        "pageRefs": [
          {
            "orderNumber": 0,
            "pageNumber": "",
            "pageRange": "",
            "title": "",
            "destination": [
              "", ...
            ]
          }, ...
        ]
      }, ...
    ]
  },
  "analysisCode": {
    "context": "",
    "expression": "",
    "documents": [
      {
        "aid": "01234567-89ab-cdef-0123-456789abcdef",
        "orderNumber": 0,
        "pageRefs": [
          {
            "orderNumber": 0,
            "pageNumber": "",
            "pageRange": "",
            "title": "",
            "destination": [
              "", ...
            ]
          }, ...
        ]
      }, ...
    ]
  }
}
```

| **Request Parameters** | **Description**                              |
| ---------------------- | -------------------------------------------- |
| `analysisReason`       | \[Optional]                                  |
| `analysisPurpose`      | \[Optional]                                  |
| `parameter`            | \[Optional] The AID of an existing Variable. |

| **analysisDataset Properties** | **Description**                            |
| ------------------------------ | ------------------------------------------ |
| `comment`                      | \[Optional] The AID of an existing Comment |

| **datasets Properties** | **Description**                 |
| ----------------------- | ------------------------------- |
| `aid`                   | The AID of an existing Dataset. |
| `orderNumber`           | Should be unique in the list.   |
| `selectionCriteria `    | \[Optional]                     |

| **variables  Properties** | **Description**                                    |
| ------------------------- | -------------------------------------------------- |
| `aid`                     | The AID of an existing Variable.                   |
| `orderNumber`             | Should be unique in the list.                      |
| `mandatory`               | \[Optional] Specifies if the property is mandatory |
| `keySequence`             | \[Optional]                                        |
| `role`                    | \[Optional]                                        |
| `method`                  | \[Optional] AID of an existing Method              |

| **analysisDocumentation Properties** | **Description** |
| ------------------------------------ | --------------- |
| `description`                        | \[Optional]     |
| `locale`                             | \[Optional]     |
| `text`                               | \[Optional]     |
| `documents`                          | \[Optional]     |

| **documents  Properties** | **Description**               |
| ------------------------- | ----------------------------- |
| `aid`                     | The AID of an existing File.  |
| `orderNumber`             | Should be unique in the list. |

| **pageRef Properties** | **Description**                         |
| ---------------------- | --------------------------------------- |
| `pageRef`              | \[Optional]                             |
| `orderNumber `         | \[Optional] must be unique in the list. |
| `pageNumber `          | \[Optional]                             |
| `pageRange `           | \[Optional]                             |
| `title`                | \[Optional]                             |
| `destination `         | \[Optional]                             |

| **analysisCode  Properties** | **Description**               |
| ---------------------------- | ----------------------------- |
| `context`                    | \[Optional]                   |
| `expression`                 | \[Optional]                   |
| `description`                | \[Optional]                   |
| `documents`                  | \[Optional]                   |
| `aid`                        | The AID of an existing File.  |
| `orderNumber`                | Should be unique in the list. |
| `pageRef`                    | \[Optional]                   |

## Terminology

When creating a Terminology, `terms` and `externalDictionary` must not be sent in the same request.

**Example with&#x20;**

```json
{
  ...
  "dataType": "STRING",
  "comment": "01234567-89ab-cdef-0123-456789abcdef",
  "terms": [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0,
      "rank": 0.0
    }
  ]
}
```

**Example with&#x20;**

```json
{
  ...
  "dataType": "STRING",
  "externalDictionary": {
    "name": "",
    "version": "",
    "localeReference": "",
    "externalReference": ""
  },
  "comment": "01234567-89ab-cdef-0123-456789abcdef"
}
```

| **Request Parameters** | **Description**                            |
| ---------------------- | ------------------------------------------ |
| `dataType `            | Must be TEXT, INTEGER, FLOAT, STRING       |
| `comment`              | \[Optional] The AID of an existing Comment |
| `externalDictionary`   | \[Optional]                                |
| `terms`                | \[Optional]                                |
| `orderNumber`          | Should be unique in the list.              |
| `rank`                 | \[Optional]                                |

'

## Term

```json
{
  ...
  "code": ""
  "display": [
    {
      "locale": "",
      "text": ""
    }, ...
  ]
}
```

Term assets ignore `clinicalStage` and `therapeuticArea` properties.

| **Request Parameters** | **Description** |
| ---------------------- | --------------- |
| `display`              | \[Optional]     |

## Comment

```json
{
  ...
  "comment": [
    {
      "locale": "",
      "text": ""
    }, ...
  ],
  "documents": [
    {
      "aid": "01234567-89ab-cdef-0123-456789abcdef",
      "orderNumber": 0,
      "pageRefs": [
        {
          "orderNumber": 0,
          "pageNumber": "",
          "pageRange": "",
          "title": "",
          "destination": [
            "", ...
          ]
        }, ...
      ]
    }, ...
  ]
}
```

| **Request Parameters** | **Description** |
| ---------------------- | --------------- |
| `comment`              | \[Optional]     |
| `locale`               | \[Optional]     |
| `text`                 | \[Optional]     |

| **documents  Properties** | **Description**               |
| ------------------------- | ----------------------------- |
| `aid`                     | The AID of an existing File.  |
| `orderNumber`             | Should be unique in the list. |

| **pageRef Properties** | **Description**                         |
| ---------------------- | --------------------------------------- |
| `pageRef`              | \[Optional]                             |
| `orderNumber `         | \[Optional] must be unique in the list. |
| `pageNumber `          | \[Optional]                             |
| `pageRange `           | \[Optional]                             |
| `title`                | \[Optional]                             |
| `destination `         | \[Optional]                             |

## File

A previously uploaded file does not need to be referenced and a File asset can be created without a file. In this case, ‘fileReferences’ is sent as an empty list and ‘entryPoint’ is omitted.

```json
{
  ...
  "fileReferences": [
    {
      "uuid": "01234567-89ab-cdef-0123-456789abcdef",
      "path": ""
    }, ...
  ],
  "entryPoint": {
    "uuid": "01234567-89ab-cdef-0123-456789abcdef",
    "path": ""
  },
  "source": ""
}
```

| **Request Parameters**         | **Description**                                            |
| ------------------------------ | ---------------------------------------------------------- |
| **fileReferences  Properties** | **Description**                                            |
| `fileReferences `              | \[Optional]                                                |
| `uuid`                         | The UUID of an existing staged file.                       |
| `path`                         | `uuid` and `path` are returned from 'Add a temporary File' |

| **entryPoint Properties** | **Description**                                                                                                                  |
| ------------------------- | -------------------------------------------------------------------------------------------------------------------------------- |
| `entryPoint`              | \[Optional]                                                                                                                      |
| `uuid`                    | The UUID of an existing staged file.                                                                                             |
| `path`                    | `uuid` and `path` are returned from 'Add a temporary File'. `uuid` and `path` should be one of the entries from ‘fileReferences’ |

| **source Properties** | **Description** |
| --------------------- | --------------- |
| `source`              | \[Optional]     |

A previously uploaded file does not need to be referenced and a File asset can be created without a file. In this case, ‘fileReferences’ is sent as an empty list and ‘entryPoint’ is omitted.

## Link

```json
{
  ...
  "urlProtocol": "",
  "urlBody": ""
}
```

| **Request Parameters** | **Description** |
| ---------------------- | --------------- |
| `urlProtocol `         | \[Optional]     |
| `urlBody `             | \[Optional]     |

# Add an Asset to an Asset Group

```json
PUT   {baseUrl}/fws/api/repository/container/containerAID/containerVersion/assetgroup/assetgroupAID/asset/assetAID
```

This request can be used to add an existing Asset to an Asset Group within a standard/study. The `containerAID` and `version` specify the standard/study, the `assetGroupAID` specifies the Asset Group to add to and `assetAID` specifies the Asset to add.

**Errors:**

****

| **HTTP Status** | **Error Code**              |                                                                         |
| --------------- | --------------------------- | ----------------------------------------------------------------------- |
| 400             | invalid\_workflow\_state    | The container is not in an editable lifecycle state.                    |
| 400             | invalid\_asset\_type        | The asset type is not valid for the asset group.                        |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the **containerAID**.        |
| 400             | invalid\_container\_version | A non numeric value was specified as the **version**.                   |
| 400             | invalid\_assetgroup\_aid    | An invalid AdministeredID was specified as the **assetgroupAID**.       |
| 400             | invalid\_asset\_aid         | An invalid AdministeredID was specified as the **assetAID**.            |
| 404             | unknown\_container          | Unknown **containerAID**/**version** pair.                              |
| 404             | unknown\_assetgroup         | Unknown **assetGroupAID** within the **containerAID**/**version** pair. |
| 404             | unknown\_asset              | Unknown **assetAID** within the **containerAID**/**version** pair.      |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

# Retrieve a List of Libraries for a Standard/Study

```json
GET   {baseUrl}/fws/api/repository/container/containerAID/version/libraries
```

This request returns a list of libraries for a standard/study in the system.  `containerAID` and `version` specify the standard/study.

`containerType `can be either STANDARD or STUDY.

`category`**&#x20;:&#x20;**&#x4E;OT\_IN\_USE, PRODUCTION, REJECTED, IN\_REVIEW, IN\_PROGRESS, DRAFT

**Example response:**

```json
[
  {
    "aid": "01234567-89ab-cdef-0123-456789abcdef",
    "containerType": "STANDARD",
    "version": 0,
    "versionLabel": "",
    "label": "",
    "name": "",
    "identifier": "",
    "status": "",
    "category":"NOT_IN_USE"
  }, ...
]

```

**Errors:**

| **HTTP Status** | **Error Code**              |                                                                  |
| --------------- | --------------------------- | ---------------------------------------------------------------- |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the **containerAID**. |
| 400             | invalid\_container\_version | A non numeric value was specified as the **version**.            |
| 404             | unknown\_container          | Unknown **containerAID**/**version** pair.                       |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

# Associate a Library with a Standard/Study

:::CodeblockTabs
Request

```json
PUT   {baseUrl}/fws/api/repository/container/containerAID/version/libraries/libraryAID/libraryVersion
```
:::

This request can be used to associate a library with a standard/study. `containerAID` and `version` specify the standard/study, and `libraryAID` and `libraryVersion` specify the library.

**Example response:**

```json
{
}
```

**Errors:**

| **HTTP Status** | **Error Code**                  |                                                                                       |
| --------------- | ------------------------------- | ------------------------------------------------------------------------------------- |
| 400             | invalid\_container\_type        | A library cannot be added to a Standard that has been Published.                      |
| 400             | invalid\_workflow\_state        | The library is not in a read-only workflow state.                                     |
| 400             | cannot\_create\_already\_exists | The specified library version is already associated with the container.               |
| 400             | invalid\_container\_aid         | An invalid AdministeredID was specified as the **containerAID**.                      |
| 400             | invalid\_container\_version     | A non numeric value was specified as the **version**.                                 |
| 400             | invalid\_library\_aid           | An invalid AdministeredID was specified as the **libraryAID**.                        |
| 400             | invalid\_library\_version       | A non numeric value was specified as the **libraryVersion**.                          |
| 404             | unknown\_container              | Unknown **containerAID**/**version** pair, or **libraryAID**/**libraryVersion** pair. |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

# Disassociate a Library with a Standard/Study

:::CodeblockTabs
Request

```json
DELETE   {baseUrl}/fws/api/repository/container/containerAID/version/libraries/libraryAID/libraryVersion
```
:::

This request can be used to disassociate a library with a standard/study. `containerAID` and `version` specify the standard/study, and `libraryAID` and `libraryVersion` specify the library.

**Example response:**

```json
{
}
```

**Errors:**

****

| **HTTP Status** | **Error Code**              |                                                                                       |
| --------------- | --------------------------- | ------------------------------------------------------------------------------------- |
| 400             | invalid\_container\_type    | A library cannot be added to a Standard that has been Published.                      |
| 400             | invalid\_workflow\_state    | The library is not in a read-only workflow state.                                     |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the **containerAID**.                      |
| 400             | invalid\_container\_version | A non numeric value was specified as the **version**.                                 |
| 400             | invalid\_library\_aid       | An invalid AdministeredID was specified as the **libraryAID**.                        |
| 400             | invalid\_library\_version   | A non numeric value was specified as the **libraryVersion**.                          |
| 404             | unknown\_container          | Unknown **containerAID**/**version** pair, or **libraryAID**/**libraryVersion** pair. |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

# Import Assets from another Asset Group

:::CodeblockTabs
Endpoint

```json
PUT   {baseUrl}/fws/api/repository/container/containerAID/containerVersion/library/import
```
:::

This request can be used to import assets from another standard/study. The source standard/study must be associated as a Library.
Imported assets include any associated child assets. `containerAID` and `containerVersion` specify the target standard/study for the imported asset. The source standard/study is specified in the request body.

**Example Request:**

```json
{
  "sourceContainer": "",
  "sourceVersion": 0,
  "targetAssetGroup": "",
  "assets": [
    "", ...
  ]
}
```

**Example response:**

```json
[
  {
    "sourceAID": "",
    "targetAID": "",
  }, ...
]

```

**Parameters:**

| **Request Parameters** | **Description**                                                                                                                                                                      |
| ---------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `sourceContainer`      | the AID of the standard/study to import assets from.                                                                                                                                 |
| `sourceVersion`        | the version number of the standard/study to import assets from.                                                                                                                      |
| `targetAssetGroup`     | \[Optional] is the AID of the asset group that the assets are to be imported to. If not set, the asset is imported into the standard/study  `containerAID` specified in the request. |
| `assets`               | lists any asset AIDs to be imported                                                                                                                                                  |

**Errors:**

| **HTTP Status** | **Error Code**              |                                                                    |
| --------------- | --------------------------- | ------------------------------------------------------------------ |
| 400             | invalid\_workflow\_state    | Container is not editable.                                         |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the **containerAID**.   |
| 400             | invalid\_container\_version | A non numeric value was specified as the **version**.              |
| 404             | unknown\_container          | Unknown **containerAID**/**version** pair.                         |
| 404             | unknown\_source\_container  | Unknown **sourceContainer** AID/**sourceVersion** pair for source. |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

# Request the Generation of an ODM for an Asset Group (Deprecated)

**Important:&#x20;**&#x54;his endpoint is deprecated, use the async version instead: [Request generation of an ODM for an Asset Group Asynchronously](https://docs.formedix.com/api/metadata#request-generation-of-an-odm-for-an-asset-group-as)&#x20;

This request can be used to generate and download the ODM / Define-XML project file for an Asset Group.

You can use the `containerAID`, `version`, and `assetgroupAID` to specify which Asset Group is generated.

A unique identifier for the download is returned. The unique identifier can then be used to request the download of the prepared file. The returned UUID should be used in the file retrieval call as the `fileUUID`. See [Retrieve a previously prepared File](#)

:::BlockQuote
Replace `containerAID`, `version`, and `assetgroupAID` with your values.
:::

:::CodeblockTabs
Request

```json
GET   {baseUrl}/fws/api/repository/container/containerAID/version/assetgroup/assetgroupAID/odm
```
:::

**Example response:**

```json
{
  "uuid": "01234567-89ab-cdef-0123-456789abcdef"
}
```

**Errors:**

| **HTTP Status** | **Error Code**              |                                                                                         |
| --------------- | --------------------------- | --------------------------------------------------------------------------------------- |
| 400             | invalid\_assetgroup\_type   | Asset groups of this type cannot have an ODM generated.                                 |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the **containerAID**.                        |
| 400             | invalid\_container\_version | A non numeric value was specified as the **version**.                                   |
| 400             | invalid\_assetgroup\_aid    | An invalid AdministeredID was specified as the **assetgroupAID**.                       |
| 404             | unknown\_container          | Unknown **containerAID**/**version** pair.                                              |
| 404             | unknown\_assetgroup         | Could not find specified **assetgroupAID** for given **containerAID**/**version** pair. |

See also [Common Errors](https://docs.formedix.com/api/common-errors)

# Request generation of an ODM for an Asset Group Asynchronously

:::CodeblockTabs
Request

```json
GET   {baseUrl}/fws/api/repository/container/containerAID/version/assetgroup/assetgroupAID/odmAsync
```
:::

Request that the ODM/XML output file for the asset group specified by `containerAID`, `version`, and `assetgroupAID `to be made available for download.

A unique identifier for the future prepared download is returned, which can then be used to request download of the file. The returned UUID should be used in the file retrieval call as the `fileUUID`.

As the file UUID is prepared in advance of the execution being completed and the file being ready, requests for the file may return 404 responses until the execution is completed in the background.

Additionally, further requests for the same ODM generation may return a 409 response with the message `already_queued` until the execution is completed in the background.

**Example Response:**

:::BlockQuote
\{
&#x20; "uuid": "01234567-89ab-cdef-0123-456789abcdef"
}

:::

**Errors:**

| **HTTP Status** | **Error Code**              |                                                                                   |
| --------------- | --------------------------- | --------------------------------------------------------------------------------- |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the containerAID.                      |
| 400             | invalid\_container\_version | A non numeric value was specified as the version.                                 |
| 400             | invalid\_assetgroup\_aid    | An invalid AdministeredID was specified as the assetgroupAID.                     |
| 404             | invalid\_assetgroup\_type   | Asset groups of this type cannot have an ODM generated.                           |
| 404             | unknown\_container          | Unknown containerAID/version pair.                                                |
| 404             | unknown\_assetgroup         | Could not find specified assetgroupAID for given containerAID/version pair.       |
| 409             | already\_queued             | The ODM generation is still in progress and cannot be queued again.               |
| 500             | other                       | The ODM generation could not be started or the output file could not be prepared. |

See also [Common Errors](https://docs.formedix.com/api/common-errors).&#x20;

# Upload the Asset Content of an ODM/Define into an Asset Group

:::CodeblockTabs
Request

```json
PUT   {baseUrl}/fws/api/repository/container/containerAID/version/assetgroup/assetgroupAID/odm
```
:::

Request for the asset content of an ODM / Define-XML project file to be uploaded to the asset group specified by the **containerAID**, **version** and **assetgroupAID**.

On success, an empty OK response is returned and the asset content of the file is added to the specified asset group.

For Data Acquisition asset groups, the expected file format is ODM

For Dataset type asset groups, a Define-XML 2.0 file is expected.



**Example Request:**

MultipartFormData containing a valid ODM/Define XML file, for example:&#x20;

:::BlockQuote
`file: “.../exampleODMFile.xml”`
:::



**Example Response:**

:::BlockQuote
\{
}
:::

**Errors:**

| **HTTP Status** | **Error Code**              |                                                                          |
| --------------- | --------------------------- | ------------------------------------------------------------------------ |
| 400             | `invalid_assetgroup_type`   | Asset groups of this type cannot have an ODM or Define uploaded to them. |
| 400             | `invalid_workflow_state`    | The container being uploaded to is in a non-editable state.              |
| 400             | `file_not_found`            | MultipartFormData does not include a file.                               |
| 400             | `invalid_container_aid`     | An invalid AID was specified as the **containerAID**.                    |
| 400             | `invalid_container_version` | A non numeric value was specified as the **version**.                    |
| 400             | `invalid_assetgroup_aid`    | An invalid AdministeredID was specified as the **assetgroupAID**.        |
| 400             | `other`                     | Indicates a problem with the file or the plugin environment.             |

See also [Common Errors](https://docs.formedix.com/api/common-errors)



# Create a New Version of an Existing Container

:::CodeblockTabs
Request

```json
PUT   {baseUrl}/fws/api/repository/container/containerAID/version/version
```
:::

Create a new version of the specified container based on the version specified.

On success, a JSON response is returned with the basic details of the new version of the container.

**Example Response:**

:::BlockQuote
\{
&#x20; "aid": "01234567-89ab-cdef-0123-456789abcdef",
&#x20; "version": 0
}
:::

| **HTTP Status** | **Error Code**              |                                                                               |
| --------------- | --------------------------- | ----------------------------------------------------------------------------- |
| 400             | invalid\_workflow\_state    | The container being versioned already has a version in an editable state.     |
| 400             | invalid\_container\_aid     | An invalid AdministeredID was specified as the **containerAID**.              |
| 400             | invalid\_container\_version | A non numeric value was specified as the **version**.                         |
| 404             | unknown\_container          | The container referred to by **containerAID**/**version** pair was not found. |
| 400             | invalid\_container\_type    | This type of container cannot be versioned by users.                          |

